--[[
###################################
Ultra XP,Rep,Azerite Bars: keivamp#
###################################
]]--

	local UltraXPRA_Bars = LibStub("AceAddon-3.0"):GetAddon("UltraXPRA_Bars")

	if (UnitLevel("player") == 120) then return end
	local MyXPWidth = 350
	local MyXPHeight = 15
	local XPX = -230
	local XPY = -10
	local XPframe = CreateFrame("Frame", nil, UIParent)
	local MyXPSettingsFrame = CreateFrame("Frame")

	local function CreateBackdrop(frame)
		frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
	end
	
	XPframe:EnableMouse(true)

	XPframe.bar = CreateFrame("StatusBar", nil, XPframe)
	XPframe.bar:SetFrameLevel(2)
	XPframe.bar:SetPoint("TOPLEFT", 0, 0)
	XPframe.bar:SetPoint("TOPRIGHT", 0, 0)

	XPframe.barR = CreateFrame("StatusBar", nil, XPframe)
	XPframe.barR:SetFrameLevel(1)
	XPframe.barR:SetPoint("TOPLEFT", 0, 0)
	XPframe.barR:SetPoint("TOPRIGHT", 0, 0)

	local XPText = XPframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			XPText:SetPoint("LEFT", 2, 0)
			-- XPText:SetWidth(MyXPWidth/2)
			-- XPText:SetJustifyH("RIGHT")
		
	local XPMaxText = XPframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			XPMaxText:SetPoint("RIGHT", -2, 0)
			-- XPMaxText:SetWidth(MyXPWidth/2)
			-- XPMaxText:SetJustifyH("LEFT")
	local XPRestedText = XPframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			XPRestedText:SetPoint("CENTER", 0, 0)
			-- XPRestedText:SetWidth(MyXPWidth/2)
			-- XPRestedText:SetJustifyH("CENTER")

local function XPMe()
	if UltraXPRA_Bars.db.char.UseUltraXP == false then return end
	--Fonts--
	local TheFont = ""
	if UltraXPRA_Bars.db.char.XPFontKey == "2002" then
	TheFont = "Fonts\\2002.ttf"
	elseif UltraXPRA_Bars.db.char.XPFontKey == "2002 Bold" then
	TheFont = "Fonts\\2002B.ttf"
	elseif UltraXPRA_Bars.db.char.XPFontKey == "AR CrystalzcuheiGBK Demibold" then
	TheFont = "Fonts\\ARHei.ttf"
	elseif UltraXPRA_Bars.db.char.XPFontKey == "AR ZhongkaiGBK Medium (Combat)" then
	TheFont = "Fonts\\ARKai_C.ttf"
	elseif UltraXPRA_Bars.db.char.XPFontKey == "AR ZhongkaiGBK Medium" then
	TheFont = "Fonts\\ARKai_T.ttf"
	elseif UltraXPRA_Bars.db.char.XPFontKey == "Arial Narrow" then
	TheFont = "Fonts\\ARIALN.ttf"
	elseif UltraXPRA_Bars.db.char.XPFontKey == "Friz Quadrata TT" then
	TheFont = "Fonts\\FRIZQT__.ttf"
	elseif UltraXPRA_Bars.db.char.XPFontKey == "MoK" then
	TheFont = "Fonts\\K_Pagetext.ttf"
	elseif UltraXPRA_Bars.db.char.XPFontKey == "Morpheus" then
	TheFont = "Fonts\\MORPHEUS_CYR.ttf"
	elseif UltraXPRA_Bars.db.char.XPFontKey == "Nimrod MT" then
	TheFont = "Fonts\\NIM_____.ttf"
	elseif UltraXPRA_Bars.db.char.XPFontKey == "Skurri" then
	TheFont = "Fonts\\SKURRI_CYR.ttf"
	else
	TheFont = "Interface\\Addons\\UltraXPRA_Bars\\Fonts\\"..UltraXPRA_Bars.db.char.XPFontKey..".ttf"
	end
	local TheFontOutline = "NONE"
	if UltraXPRA_Bars.db.char.XPFontOutline == 1 then
	TheFontOutline = "NONE"
	elseif UltraXPRA_Bars.db.char.XPFontOutline == 2 then
	TheFontOutline = "MONOCHROMEOUTLINE"
	elseif UltraXPRA_Bars.db.char.XPFontOutline == 3 then
	TheFontOutline = "THINOUTLINE"
	elseif UltraXPRA_Bars.db.char.XPFontOutline == 4 then
	TheFontOutline = "THICKOUTLINE"
	end
		if UltraXPRA_Bars.db.char.XPFontKey == "Folkard" then
			XPText:SetPoint("LEFT", 2, -3)
			XPMaxText:SetPoint("RIGHT", -2, -3)
			XPRestedText:SetPoint("CENTER", 0, -3)
		elseif UltraXPRA_Bars.db.char.XPFontKey == "Atari" then
			XPText:SetPoint("LEFT", 2, 2)
			XPMaxText:SetPoint("RIGHT", -2, 2)
			XPRestedText:SetPoint("CENTER", 0, 2)
		else
			XPText:SetPoint("LEFT", 2, 0)
			XPMaxText:SetPoint("RIGHT", -2, 0)
			XPRestedText:SetPoint("CENTER", 0, 0)
		end
	
	
	--end fonts --
	--print(UltraXPRA_Bars.db.char.FontOutline)
	--print("XP")
	local MyXPWidth = UltraXPRA_Bars.db.char.XPWidth
	local MyXPHeight = UltraXPRA_Bars.db.char.XPHeight
	local XPX = UltraXPRA_Bars.db.char.XPMoveX
	local XPY = UltraXPRA_Bars.db.char.XPMoveY
	
	XPframe:SetClampedToScreen(true)
	XPframe:SetClampRectInsets(0, 0, 0,0)

	XPframe:SetHeight(MyXPHeight)
	XPframe:SetWidth(MyXPWidth)

	XPframe:ClearAllPoints()
	XPframe:SetPoint("TOP", UIParent, "TOP", XPX,XPY)
		
	XPframe:CreateBeautyBorder(4)
	XPframe:SetBeautyBorderPadding(1)
	XPframe:SetBeautyBorderTexture("white")
	
	CreateBackdrop(XPframe)
	
	if UltraXPRA_Bars.db.char.UseVertXP == true then
		XPframe.bar:SetOrientation("VERTICAL")
		XPframe.barR:SetOrientation("VERTICAL")
		UltraXPRA_Bars.db.char.ShowRested = false
		UltraXPRA_Bars.db.char.ShowMaxXP = false
		UltraXPRA_Bars.db.char.ShowMinXP = false	
	else
		XPframe.bar:SetOrientation("HORIZONTAL")
		XPframe.barR:SetOrientation("HORIZONTAL")
	end
	
	XPframe.bar:SetHeight(MyXPHeight)
	XPframe.barR:SetHeight(MyXPHeight)
	XPframe.bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	XPframe.bar:GetStatusBarTexture():SetHorizTile(false)
	XPframe.bar:GetStatusBarTexture():SetVertTile(false)
	XPframe.bar:SetStatusBarColor(.41,.60,.95)
	XPframe:SetBeautyBorderColor(.41,.60,.95,0.75)
	XPframe.barR:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	XPframe.barR:GetStatusBarTexture():SetHorizTile(false)
	XPframe.barR:GetStatusBarTexture():SetVertTile(false)
	XPframe.barR:SetStatusBarColor(.6,.2,.8,1)
	if UltraXPRA_Bars.db.char.XPCustomFont == false then 
	XPText:SetFont("SystemFont_Med1", MyXPHeight-4, "OUTLINE")
	XPText:SetTextColor(1, 1, 1, 1);
	XPMaxText:SetFont("SystemFont_Med1", MyXPHeight-4, "OUTLINE")
	XPMaxText:SetTextColor(1, 1, 1, 1);
	XPRestedText:SetFont("SystemFont_Med1", MyXPHeight-4, "OUTLINE")	
	XPRestedText:SetTextColor(1, 1, 1, 1);
	else
	XPText:SetFont(TheFont, UltraXPRA_Bars.db.char.XPFontSize, TheFontOutline)	
	XPMaxText:SetFont(TheFont, UltraXPRA_Bars.db.char.XPFontSize, TheFontOutline)	
	--XPRestedText:SetFont("Interface\\Addons\\UltraXPRA_Bars\\Fonts\\"..TheFont..".ttf", MyXPHeight-4, "THINOUTLINE")
	XPRestedText:SetFont(TheFont, UltraXPRA_Bars.db.char.XPFontSize, TheFontOutline)		
	end	
	
	-- XPRestedText:SetWidth(MyXPWidth/3)
	-- XPMaxText:SetWidth(MyXPWidth/3)
	-- XPText:SetWidth(MyXPWidth/3)

	
end	
MyXPSettingsFrame:HookScript("OnUpdate",XPMe) 
function truncate(number, decimals)
    return number - (number % (0.1 ^ decimals))
end

local function UpdateXP()
	if UltraXPRA_Bars.db.char.UseUltraXP == false then return end
		XPframe.bar:SetMinMaxValues(0, UnitXPMax("player"))
		XPframe.bar:SetValue(UnitXP("player"))	
		local rested = GetXPExhaustion()
		if rested ~= nil then		
		local restedPerc = math.floor(rested / UnitXPMax("player") * 100 + 0.5)
		if UltraXPRA_Bars.db.char.ShowMinXP == true then 
			if UnitXP("player") > 1000 then
			XPText:SetText(truncate(UnitXP("player")/1000,1).."K")
			else
			XPText:SetText(UnitXP("player"))
			end
		else
		XPText:SetText("")
		end
		if UltraXPRA_Bars.db.char.ShowMaxXP == true then 
			if UnitXPMax("player") > 1000 then
				XPMaxText:SetText(truncate(UnitXPMax("player")/1000,1).."K")
			else
				XPMaxText:SetText(UnitXPMax("player"))
			end
		else
		XPMaxText:SetText("")
		end	
		if UltraXPRA_Bars.db.char.ShowRested == true then 
		XPRestedText:SetText(restedPerc.."% Rested")
		else
		XPRestedText:SetText("")
		end
		XPframe.barR:SetMinMaxValues(0, UnitXPMax("player"))
		XPframe.barR:SetValue(UnitXP("player")+rested)
		end
		if rested == nil then
		XPText:SetText(UnitXP("player"))
		XPMaxText:SetText(UnitXPMax("player"))
		XPRestedText:SetText("")
		XPframe.barR:SetStatusBarColor(0,0,0,0)
		end
		--OnEvent()
		
end
	local function OnEvent(self)
		if UltraXPRA_Bars.db.char.UseUltraXP == false then return end
		self:SetScript("OnEnter", function()
			
			local rested = GetXPExhaustion()
			
			GameTooltip:SetOwner(self, "ANCHOR_BOTTOM", 0, -10)
			GameTooltip:ClearAllPoints()
			GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
			GameTooltip:ClearLines()

			GameTooltip:AddDoubleLine("Experience")
			GameTooltip:AddLine(" ")
			GameTooltip:AddDoubleLine(UnitXP("player") .. "  /  " .. UnitXPMax("player"))
			if rested ~= nil then		
				local restedPerc = math.floor(rested / UnitXPMax("player") * 100 + 0.5)
				GameTooltip:AddLine(" ")
				GameTooltip:AddDoubleLine(restedPerc .. "% : Rested XP")
			end
			GameTooltip:Show()
		end)		
		self:SetScript("OnLeave", function() GameTooltip:Hide() end)
		end

		XPframe:SetScript("OnEvent", OnEvent)
		XPframe:HookScript("OnUpdate", OnEvent)
		
		XPframe.UpdateFrame = CreateFrame("Frame", nil, UIParent);

XPframe.UpdateFrame:HookScript("OnUpdate", UpdateXP)

